package findprimes

import edu.rice.cnc.api.Point


/**
 * @author Shams Imam (shams@rice.edu)
 * @since 1/2/12 10:34 AM
 */

object FindPrimesMain {

  def main(args: Array[String]): Unit = {
    if (args.length == 1) {
      val n: Int = java.lang.Integer.parseInt(args(0))

      // Create an instance of all the steps in the program
      val step = new UserComputeStep()
      // Create an instance of the graph class
      val graph = new FindPrimesGraph(step)
      println("Determining primes from 1-" + n)

      // Env puts odd numbers from 3..n to prescribe the compute step instances
      // We need to enclose this in a Finish scope so that all the computation will be
      // done by the time we dump all the contents of the primes collection
      graph.run(new Runnable() {
        def run(): Unit = {
          var number: Int = 3
          while (number < n) {
            graph.oddNums.put(Point.create(number))
            number += 2
          }
        }
      })

      println("Number of primes: " + graph.primes.size)
      graph.primes.dump(System.out)

    } else {
      println("Usage: FindPrimesMain n")
    }
  }
}