import edu.rice.cnc.translator.GraphDescription._
import edu.rice.cnc.api.Point

/**
 * @author Shams Imam (shams@rice.edu)
 * @since 1/3/12 7:39 PM
 */

object NQueensCncDefinition {
  def main(args: Array[String]): Unit = {
    ApplicationName("NQueens")
    TargetPackage("nqueens") // default package
    TargetDirectory("nqueens")

    Comment("Item Collections")
    ItemCollection[Point, Int]("boardSize")
    ItemCollection[Point, Int]("valuesPer32Bits")
    ItemCollection[Point, Byte]("solutions")

    Comment("Tag Collections")
    TagCollection[Point]("partialConfigurationTag")

    Comment("Step Prescriptions")
    Presription("partialConfigurationTag", List("ProcessPositionStep"))

    Comment("Step Dependences")
    StepDependence("ProcessPositionStep",
      List[String]("valuesPer32Bits", "boardSize"),
      List("solutions", "partialConfigurationTag"))

    Comment("Environment Collections")
    EnvironmentDependence(
      List("valuesPer32Bits", "boardSize", "partialConfigurationTag"),
      List("solutions")
    )
  }
}