import edu.rice.cnc.translator.GraphDescription._

/**
 * @author Shams Imam (shams@rice.edu)
 * @since 1/2/12 5:23 PM
 */

object PartitionStringCncDefinition {
  def main(args: Array[String]): Unit = {
    ApplicationName("PartitionString")
    TargetPackage("partitionstring") // default package
    TargetDirectory("partitionstring")

    Comment("Item Collections")
    ItemCollection[String, String]("input")
    ItemCollection[String, String]("span")
    ItemCollection[String, String]("results")

    Comment("Tag Collections")
    TagCollection[String]("singletonTag")
    TagCollection[String]("spanTags")

    Comment("Step Prescriptions")
    Presription("singletonTag", List("createSpan"))
    Presription("spanTags", List("processSpan"))

    Comment("Step Dependences")
    StepDependence("createSpan", List[String]("input"), List("spanTags", "span"))
    StepDependence("processSpan", List[String]("span"), List("results"))

    Comment("Environment Collections")
    EnvironmentDependence(
      List("input", "singletonTag"),
      List("results")
    )
  }
}