package partitionstring

import util.continuations.cps


/**
 * @author Shams Imam (shams@rice.edu)
 * @since 1/2/12 10:35 AM
 */

object PartitionStringMain {

  def main(args: Array[String]): Unit = {
    if (args.length > 0) {
      val createStep = new UserCreateSpanStep()
      val processStep = new UserProcessSpanStep()
      val graph = new PartitionStringGraph(createStep, processStep)

      graph.run(new Runnable() {
        def run(): Unit = {
          val arg = args(0)
          graph.input.put(arg, arg)
          graph.singletonTag.put(arg)
        }
      })

      graph.results.dump(System.out)
    } else {
      println("Usage: PartitionStringMain <string_to_process>")
    }
  }

}