package partitionstring

import edu.rice.cnc.api._
import java.lang.String
import util.continuations.cps

/**
 * @author Shams Imam (shams@rice.edu)
 * @since 1/2/12 10:35 AM
 */

class UserCreateSpanStep extends CreateSpanStep {
  def compute(
               tag: String,
               inInput: InputCollection[String, String],
               outSpanTags: TagCollection[String],
               outSpan: OutputCollection[String, String]
               ): Unit@cps[Any] = {

    // Get input string
    val in: String = inInput.get(tag)

    if (in.length() != 0) {
      var ch: Char = in.charAt(0)
      var len: Int = 0
      var i: Int = 0
      var j: Int = 0
      while (i < in.length()) {
        if (in.charAt(i) == ch) {
          i += 1
          len += 1
        } else {
          val jStr = String.valueOf(j)
          outSpan.put(jStr, in.substring(j, j + len))
          outSpanTags.put(jStr)
          ch = in.charAt(i)
          len = 0
          j = i
        }
      }
      val jStr: String = String.valueOf(j)
      outSpan.put(jStr, in.substring(j, j + len))
      outSpanTags.put(jStr)
    }
  }
}

class UserProcessSpanStep extends ProcessSpanStep {
  def compute(
               tag: String,
               inSpan: InputCollection[String, String],
               outResults: OutputCollection[String, String]
               ): Unit@cps[Any] = {

    val toProcess = inSpan.get(tag)

    if ((toProcess.length() % 2) != 0) {
      outResults.put(tag, toProcess)
    }
  }
}